var AdvPopup;

AdvPopup = AdvPopup || {};

Backbone.Events.on('layer:register', function(app) {
	var Layer, LayerOptionsView, LayerView;
	if (app.isBackend) {
		LayerView = AdvPopup.LayerView.extend({
			initialize: function() {
				var fieldId, that, tmpEl;
				this.defaultInitialize();
				this.$img = jQuery('<img class="advp-layer-image"></div>');
				if (this.model.isNewLayer) {
					that = this;
					fieldId = 'tmp-input-' + this.model.cid;
					tmpEl = jQuery('<input type="hidden" id="' + fieldId + '" />').appendTo('body').on('change', function() {
						var image, img;
						image = jQuery(this).val();
						img = new Image;
						img.src = AdvPopup.Common.getAbsUrl(image);
						jQuery(img).on('load', function() {
							that.model.set({
								width: img.width,
								height: img.height,
								image: image
							});
						});
					});
					jQuery.fancybox.open({
						href: 'index.php?option=com_media&view=images&tmpl=component&fieldid=' + fieldId,
						width: 800,
						height: 500,
						overlay: true,
						type: 'iframe',
						afterClose: function() {
							return tmpEl.remove();
						}
					});
				}
				this.render();
			},
			render: function(view, options) {
				var image;
				if (image = this.model.get('image')) {
					this.$img.attr('src', AdvPopup.Common.getAbsUrl(image)).appendTo(this.$inner);
				} else {
					this.$img.detach();
				}
				this.$inner.css({
					backgroundColor: this.model.get('color')
				});
				this.defaultRender();
			}
		});
		LayerOptionsView = AdvPopup.OptionsView.extend({
			title: 'Image Options',
			optionsTemplate: _.template('<div  class="form-horizontal"> <div class="control-group"> <label class="control-label">Image</label> <div class="controls"> <div class="input-append"> <input type="text" class="advp-option-image" value="<%- image %>" /> <a href="#" class="btn btn-default btn-change-option-image">Select Image</a> </div> </div> </div> <div class="control-group"> <label class="control-label">Image Hover</label> <div class="controls"> <div class="input-append"> <input type="text" class="advp-option-image-hover" value="<%- image_hover %>" /> <a href="#" class="btn btn-default btn-change-option-image">Select Image</a> </div> </div> </div> <div class="control-group"> <label class="control-label">Alternate Text</label> <div class="controls"> <input type="text" class="advp-option-alt" value="<%- alt %>" /> </div> </div> <div class="control-group"> <label class="control-label">Color</label> <div class="controls"> <input type="text" class="advp-option-color" value="<%- color %>" /> </div> </div> <div class="control-group"> <label class="control-label">Left</label> <div class="controls"> <input type="text" class="advp-option-left" value="<%- left %>" /> </div> </div> <div class="control-group"> <label class="control-label">Top</label> <div class="controls"> <input type="text" class="advp-option-top" value="<%- top %>" /> </div> </div> <div class="control-group"> <label class="control-label">Width</label> <div class="controls"> <input type="text" class="advp-option-width" value="<%- width %>" /> </div> </div> <div class="control-group"> <label class="control-label">Height</label> <div class="controls"> <input type="text" class="advp-option-height" value="<%- height %>" /> </div> </div> <div class="control-group"> <label class="control-label">Angle</label> <div class="controls"> <input type="text" class="advp-option-angle" value="<%- angle %>" /> </div> </div> <div class="control-group"> <label class="control-label">Function</label> <div class="controls"> <select class="advp-option-func"> <option value=""<%= func === \'\' ? \'selected="selected"\' : \'\' %>>None</option> <option value="close"<%= func === \'close\' ? \'selected="selected"\' : \'\' %>>Close Popup</option> <option value="music"<%= func === \'music\' ? \'selected="selected"\' : \'\' %>>On/Off Music</option> <option value="link"<%= func === \'link\' ? \'selected="selected"\' : \'\' %>>Open URL</option> </select> </div> </div> <div class="control-group"> <label class="control-label">Link URL</label> <div class="controls"> <input type="text" class="advp-option-url" value="<%- url %>" /> </div> </div> <div class="control-group"> <label class="control-label">Open Link in</label> <div class="controls"> <select class="advp-option-link-target"> <option value=""<%= func === \'\' ? \'selected="selected"\' : \'\' %>>Same Tab</option> <option value="_blank"<%= func === \'_blank\' ? \'selected="selected"\' : \'\' %>>New Tab</option> </select> </div> </div> </div>'),
			events: {
				'change input': 'updateOptions',
				'change select': 'updateOptions',
				'click .btn-change-option-image': 'selectImage'
			},
			render: function() {
				var that;
				this.defaultRender();
				that = this;
				this.$('.advp-option-image').attr('id', 'advp-option-image-' + this.model.cid);
				this.$('.advp-option-image-hover').attr('id', 'advp-option-image-hover-' + this.model.cid);
				this.$('.advp-option-color').minicolors({
					change: function(value, opacity) {
						that.modelSet({
							color: value += ', ' + opacity
						});
					}
				});
			},
			updateOptions: function() {
				return this.modelSet({
					left: parseInt(this.$('.advp-option-left').val()) || 20,
					top: parseInt(this.$('.advp-option-top').val()) || 20,
					width: parseInt(this.$('.advp-option-width').val()) || 50,
					height: parseInt(this.$('.advp-option-height').val()) || 50,
					angle: this.model.toDegrees(parseFloat(this.$('.advp-option-angle').val()) || 0),
					image: this.$('.advp-option-image').val(),
					image_hover: this.$('.advp-option-image-hover').val(),
					alt: this.$('.advp-option-alt').val(),
					color: this.$('.advp-option-color').val(),
					func: this.$('.advp-option-func').val(),
					url: this.$('.advp-option-url').val(),
					link_target: this.$('.advp-option-link-target').val()
				});
			},
			selectImage: function(event) {
				var fieldId, that;
				that = this;
				fieldId = jQuery(event.target).closest('.controls').find('input').attr('id');
				jQuery.fancybox.open({
					href: 'index.php?option=com_media&view=images&tmpl=component&fieldid=' + fieldId,
					width: 800,
					height: 500,
					overlay: true,
					type: 'iframe',
					afterClose: function() {
						that.updateOptions();
					}
				});
			}
		});
	} else {
		LayerView = AdvPopup.LayerView.extend({
			events: {
				'click': 'imageClick'
			},
			initialize: function() {
				this.defaultInitialize();
				return this.$img = jQuery('<img class="advp-layer-image" />');
			},
			render: function() {
				var $link, image, image_hover, target, that, url;
				that = this;
				if (this.model.get('func') === 'link' && (url = this.model.get('url'))) {
					$link = jQuery('<a href="' + AdvPopup.Common.getAbsUrl(url + '"></a>')).appendTo(this.$inner);
					if (target = this.model.get('link_target')) {
						$link.attr('target', target);
					}
				}
				if (image = this.model.get('image')) {
					this.$img.attr('src', AdvPopup.Common.getAbsUrl(image)).appendTo($link ? $link : this.$inner);
				} else {
					this.$img.detach();
				}
				this.$inner.css({
					backgroundColor: this.model.get('color')
				});
				if (image && (image_hover = this.model.get('image_hover'))) {
					this.$el.on({
						mouseenter: function() {
							that.$img.attr('src', AdvPopup.Common.getAbsUrl(image_hover));
						},
						mouseleave: function() {
							that.$img.attr('src', AdvPopup.Common.getAbsUrl(image));
						}
					});
				}
				this.defaultRender();
			},
			imageClick: function(event) {
				if ((this.$el.has(event.target)).length) {
					switch (this.model.get('func')) {
						case 'close':
							return AdvPopup.app.closePopup();
						case 'music':
							return AdvPopup.app.toggleMusic();
					}
				}
			}
		});
	}
	Layer = AdvPopup.Layer.extend({
		defaults: _.extend({}, AdvPopup.Layer.prototype.defaults, {
			type: 'image',
			image: '',
			image_hover: '',
			alt: '',
			color: '',
			func: '',
			url: '',
			link_target: ''
		}),
		initialize: function(attrs, options) {
			if (attrs) {
				this.isNewLayer = false;
			}
			if (app.isBackend) {
				this.view = new LayerView({
					id: 'layer-' + this.cid,
					model: this
				});
				this.optionsView = new LayerOptionsView({
					id: 'layer-options-' + this.cid,
					model: this
				});
				this.defaultInitialize();
			} else {
				this.view = new LayerView({
					id: 'layer-' + this.cid,
					model: this
				});
			}
		},
		getCaption: function() {
			var caption;
			if (!(caption = this.get('alt'))) {
				caption = 'Layer Image ' + this.cid;
			}
			return '<i class="fa fa-picture-o"></i> ' + caption;
		}
	});
	return app.registerLayerClass(Layer);
});
