var AdvPopup;

AdvPopup = AdvPopup || {};

Backbone.Events.on('layer:register', function(app) {
	var Layer, LayerOptionsView, LayerView;
	if (app.isBackend) {
		LayerView = AdvPopup.LayerView.extend({
			initialize: function() {
				this.defaultInitialize();
				this.$text = jQuery('<div class="advp-layer-text"></div>').appendTo(this.$inner);
				this.render();
			},
			render: function() {
				this.$text.html(this.model.get('text'));
				this.defaultRender();
			}
		});
		LayerOptionsView = AdvPopup.OptionsView.extend({
			title: 'Text Options',
			optionsTemplate: _.template('<div  class="form-horizontal"> <div class="control-group"> <label class="control-label">Text/Html</label> <div class="controls"> <textarea rows="5" class="advp-option-text"><%= text %></textarea> </div> </div> <div class="control-group"> <label class="control-label">Left</label> <div class="controls"> <input type="text" class="advp-option-left" value="<%- left %>" /> </div> </div> <div class="control-group"> <label class="control-label">Top</label> <div class="controls"> <input type="text" class="advp-option-top" value="<%- top %>" /> </div> </div> <div class="control-group"> <label class="control-label">Angle</label> <div class="controls"> <input type="text" class="advp-option-angle" value="<%- angle %>" /> </div> </div> </div>'),
			events: {
				'change input': 'updateOptions',
				'change textarea': 'updateOptions'
			},
			updateOptions: function() {
				this.modelSet({
					left: parseInt(this.$('.advp-option-left').val()) || 20,
					top: parseInt(this.$('.advp-option-top').val()) || 20,
					angle: this.model.toDegrees(parseFloat(this.$('.advp-option-angle').val()) || 0),
					text: this.$('.advp-option-text').val()
				});
			}
		});
	} else {
		LayerView = AdvPopup.LayerView.extend({
			initialize: function() {
				this.defaultInitialize();
				return this.$text = jQuery('<div class="advp-layer-text"></div>').appendTo(this.$inner);
			},
			render: function() {
				this.$text.html(this.model.get('text'));
				this.defaultRender();
			}
		});
	}
	Layer = AdvPopup.Layer.extend({
		defaults: _.extend({}, AdvPopup.Layer.prototype.defaults, {
			type: 'text',
			text: ''
		}),
		sizeChangable: false,
		initialize: function(attrs, options) {
			if (attrs) {
				this.isNewLayer = false;
			}
			if (app.isBackend) {
				if (this.isNewLayer) {
					this.set('text', 'Layer Text ' + this.cid);
				}
				this.view = new LayerView({
					id: 'advp-layer-' + this.cid,
					model: this
				});
				this.optionsView = new LayerOptionsView({
					id: 'advp-layer-options-' + this.cid,
					model: this
				});
				this.defaultInitialize();
			} else {
				this.view = new LayerView({
					id: 'advp-layer-' + this.cid,
					model: this
				});
			}
		},
		getCaption: function() {
			var caption;
			if (caption = this.get('text')) {
				caption = jQuery('<div>' + caption + '</div>').text().substr(0, 20);
			}
			if (!caption) {
				caption = 'Layer Text ' + this.cid;
			}
			return '<i class="fa fa-text-width"></i> ' + caption;
		}
	});
	return app.registerLayerClass(Layer);
});
