/*
 * jQuery MiniColors: A tiny color picker built on jQuery
 *
 * Copyright: Cory LaViska for A Beautiful Site, LLC: http://www.abeautifulsite.net/
 *
 * Contribute: https://github.com/claviska/jquery-minicolors
 *
 * @license: http://opensource.org/licenses/MIT
 *
 */
(function(a){if(typeof define==='function'&&define.amd){define(['jquery'],a)}else if(typeof exports==='object'){module.exports=a(require('jquery'))}else{a(jQuery)}}(function($){$.minicolors={defaults:{animationSpeed:50,animationEasing:'swing',change:null,changeDelay:0,control:'hue',dataUris:true,defaultValue:'',format:'hex',hide:null,hideSpeed:100,inline:false,keywords:'',letterCase:'lowercase',opacity:false,position:'bottom left',show:null,showSpeed:100,theme:'default'}};$.extend($.fn,{minicolors:function(b,c){switch(b){case'destroy':$(this).each(function(){destroy($(this))});return $(this);case'hide':hide();return $(this);case'opacity':if(c===undefined){return $(this).attr('data-opacity')}else{$(this).each(function(){updateFromInput($(this).attr('data-opacity',c))})}return $(this);case'rgbObject':return rgbObject($(this),b==='rgbaObject');case'rgbString':case'rgbaString':return rgbString($(this),b==='rgbaString');case'settings':if(c===undefined){return $(this).data('minicolors-settings')}else{$(this).each(function(){var a=$(this).data('minicolors-settings')||{};destroy($(this));$(this).minicolors($.extend(true,a,c))})}return $(this);case'show':show($(this).eq(0));return $(this);case'value':if(c===undefined){return $(this).val()}else{$(this).each(function(){if(typeof(c)==='object'){if(c.opacity){$(this).attr('data-opacity',keepWithin(c.opacity,0,1))}if(c.color){$(this).val(c.color)}}else{$(this).val(c)}updateFromInput($(this))})}return $(this);default:if(b!=='create')c=b;$(this).each(function(){init($(this),c)});return $(this)}}});function init(b,c){var d=$('<div class="minicolors" />'),defaults=$.minicolors.defaults,format=b.attr('data-format'),keywords=b.attr('data-keywords'),opacity=b.attr('data-opacity');if(b.data('minicolors-initialized'))return;c=$.extend(true,{},defaults,c);d.addClass('minicolors-theme-'+c.theme).toggleClass('minicolors-with-opacity',c.opacity).toggleClass('minicolors-no-data-uris',c.dataUris!==true);if(c.position!==undefined){$.each(c.position.split(' '),function(){d.addClass('minicolors-position-'+this)})}$input_size=opacity?'25':'20';b.addClass('minicolors-input').data('minicolors-initialized',false).data('minicolors-settings',c).prop('size',$input_size).wrap(d).after('<div class="minicolors-panel minicolors-slider-'+c.control+'">'+'<div class="minicolors-slider minicolors-sprite">'+'<div class="minicolors-picker"></div>'+'</div>'+'<div class="minicolors-opacity-slider minicolors-sprite">'+'<div class="minicolors-picker"></div>'+'</div>'+'<div class="minicolors-grid minicolors-sprite">'+'<div class="minicolors-grid-inner"></div>'+'<div class="minicolors-picker"><div></div></div>'+'</div>'+'</div>');if(!c.inline){b.after('<span class="minicolors-swatch minicolors-sprite"><span class="minicolors-swatch-color"></span></span>');b.next('.minicolors-swatch').on('click',function(a){a.preventDefault();b.focus()})}b.parent().find('.minicolors-panel').on('selectstart',function(){return false}).end();if(c.inline)b.parent().addClass('minicolors-inline');updateFromInput(b,false);b.data('minicolors-initialized',true)}function destroy(a){var b=a.parent();a.removeData('minicolors-initialized').removeData('minicolors-settings').removeProp('size').removeClass('minicolors-input');b.before(a).remove()}function show(a){var b=a.parent(),panel=b.find('.minicolors-panel'),settings=a.data('minicolors-settings');if(!a.data('minicolors-initialized')||a.prop('disabled')||b.hasClass('minicolors-inline')||b.hasClass('minicolors-focus'))return;hide();b.addClass('minicolors-focus');panel.stop(true,true).fadeIn(settings.showSpeed,function(){if(settings.show)settings.show.call(a.get(0))})}function hide(){$('.minicolors-focus').each(function(){var a=$(this),input=a.find('.minicolors-input'),panel=a.find('.minicolors-panel'),settings=input.data('minicolors-settings');panel.fadeOut(settings.hideSpeed,function(){if(settings.hide)settings.hide.call(input.get(0));a.removeClass('minicolors-focus')})})}function move(a,b,c){var d=a.parents('.minicolors').find('.minicolors-input'),settings=d.data('minicolors-settings'),picker=a.find('[class$=-picker]'),offsetX=a.offset().left,offsetY=a.offset().top,x=Math.round(b.pageX-offsetX),y=Math.round(b.pageY-offsetY),duration=c?settings.animationSpeed:0,wx,wy,r,phi;if(b.originalEvent.changedTouches){x=b.originalEvent.changedTouches[0].pageX-offsetX;y=b.originalEvent.changedTouches[0].pageY-offsetY}if(x<0)x=0;if(y<0)y=0;if(x>a.width())x=a.width();if(y>a.height())y=a.height();if(a.parent().is('.minicolors-slider-wheel')&&picker.parent().is('.minicolors-grid')){wx=75-x;wy=75-y;r=Math.sqrt(wx*wx+wy*wy);phi=Math.atan2(wy,wx);if(phi<0)phi+=Math.PI*2;if(r>75){r=75;x=75-(75*Math.cos(phi));y=75-(75*Math.sin(phi))}x=Math.round(x);y=Math.round(y)}if(a.is('.minicolors-grid')){picker.stop(true).animate({top:y+'px',left:x+'px'},duration,settings.animationEasing,function(){updateFromControl(d,a)})}else{picker.stop(true).animate({top:y+'px'},duration,settings.animationEasing,function(){updateFromControl(d,a)})}}function updateFromControl(d,e){function getCoords(a,b){var c,top;if(!a.length||!b)return null;c=a.offset().left;top=a.offset().top;return{x:c-b.offset().left+(a.outerWidth()/2),y:top-b.offset().top+(a.outerHeight()/2)}}var f,saturation,brightness,x,y,r,phi,hex=d.val(),format=d.attr('data-format'),keywords=d.attr('data-keywords'),opacity=d.attr('data-opacity'),minicolors=d.parent(),settings=d.data('minicolors-settings'),swatch=minicolors.find('.minicolors-swatch'),grid=minicolors.find('.minicolors-grid'),slider=minicolors.find('.minicolors-slider'),opacitySlider=minicolors.find('.minicolors-opacity-slider'),gridPicker=grid.find('[class$=-picker]'),sliderPicker=slider.find('[class$=-picker]'),opacityPicker=opacitySlider.find('[class$=-picker]'),gridPos=getCoords(gridPicker,grid),sliderPos=getCoords(sliderPicker,slider),opacityPos=getCoords(opacityPicker,opacitySlider);if(e.is('.minicolors-grid, .minicolors-slider, .minicolors-opacity-slider')){switch(settings.control){case'wheel':x=(grid.width()/2)-gridPos.x;y=(grid.height()/2)-gridPos.y;r=Math.sqrt(x*x+y*y);phi=Math.atan2(y,x);if(phi<0)phi+=Math.PI*2;if(r>75){r=75;gridPos.x=69-(75*Math.cos(phi));gridPos.y=69-(75*Math.sin(phi))}saturation=keepWithin(r/0.75,0,100);f=keepWithin(phi*180/Math.PI,0,360);brightness=keepWithin(100-Math.floor(sliderPos.y*(100/slider.height())),0,100);hex=hsb2hex({h:f,s:saturation,b:brightness});slider.css('backgroundColor',hsb2hex({h:f,s:saturation,b:100}));break;case'saturation':f=keepWithin(parseInt(gridPos.x*(360/grid.width()),10),0,360);saturation=keepWithin(100-Math.floor(sliderPos.y*(100/slider.height())),0,100);brightness=keepWithin(100-Math.floor(gridPos.y*(100/grid.height())),0,100);hex=hsb2hex({h:f,s:saturation,b:brightness});slider.css('backgroundColor',hsb2hex({h:f,s:100,b:brightness}));minicolors.find('.minicolors-grid-inner').css('opacity',saturation/100);break;case'brightness':f=keepWithin(parseInt(gridPos.x*(360/grid.width()),10),0,360);saturation=keepWithin(100-Math.floor(gridPos.y*(100/grid.height())),0,100);brightness=keepWithin(100-Math.floor(sliderPos.y*(100/slider.height())),0,100);hex=hsb2hex({h:f,s:saturation,b:brightness});slider.css('backgroundColor',hsb2hex({h:f,s:saturation,b:100}));minicolors.find('.minicolors-grid-inner').css('opacity',1-(brightness/100));break;default:f=keepWithin(360-parseInt(sliderPos.y*(360/slider.height()),10),0,360);saturation=keepWithin(Math.floor(gridPos.x*(100/grid.width())),0,100);brightness=keepWithin(100-Math.floor(gridPos.y*(100/grid.height())),0,100);hex=hsb2hex({h:f,s:saturation,b:brightness});grid.css('backgroundColor',hsb2hex({h:f,s:100,b:100}));break}if(settings.opacity){opacity=parseFloat(1-(opacityPos.y/opacitySlider.height())).toFixed(2)}else{opacity=1}if(settings.opacity)d.attr('data-opacity',opacity);if(format==='rgb'||(d.minicolors('rgbObject').a<1&&settings.opacity)){var g=hex2rgb(hex),opacity=d.attr('data-opacity')===''?1:keepWithin(parseFloat(d.attr('data-opacity')).toFixed(2),0,1);if(isNaN(opacity)||!settings.opacity)opacity=1;if(d.minicolors('rgbObject').a<=1&&g&&settings.opacity){value='rgba('+g.r+', '+g.g+', '+g.b+', '+parseFloat(opacity)+')'}else{value='rgb('+g.r+', '+g.g+', '+g.b+')'}}else{value=convertCase(hex,settings.letterCase)}d.val(value)}swatch.find('span').css({backgroundColor:hex,opacity:opacity});doChange(d,value,opacity)}function updateFromInput(b,c){var d,hsb,format=b.attr('data-format'),keywords=b.attr('data-keywords'),opacity,x,y,r,phi,minicolors=b.parent(),settings=b.data('minicolors-settings'),swatch=minicolors.find('.minicolors-swatch'),grid=minicolors.find('.minicolors-grid'),slider=minicolors.find('.minicolors-slider'),opacitySlider=minicolors.find('.minicolors-opacity-slider'),gridPicker=grid.find('[class$=-picker]'),sliderPicker=slider.find('[class$=-picker]'),opacityPicker=opacitySlider.find('[class$=-picker]');if(isRgb(b.val())){d=rgbString2hex(b.val());alpha=keepWithin(parseFloat(getAlpha(b.val())).toFixed(2),0,1);if(alpha){b.attr('data-opacity',alpha)}}else{d=convertCase(parseHex(b.val(),true),settings.letterCase)}if(!d){d=convertCase(parseInput(settings.defaultValue,true),settings.letterCase)}hsb=hex2hsb(d);keywords=!keywords?[]:$.map(keywords.split(','),function(a){return $.trim(a.toLowerCase())});if(b.val()!==''&&$.inArray(b.val().toLowerCase(),keywords)>-1){value=convertCase(b.val())}else{value=isRgb(b.val())?parseRgb(b.val()):d}if(!c)b.val(value);if(settings.opacity){opacity=b.attr('data-opacity')===''?1:keepWithin(parseFloat(b.attr('data-opacity')).toFixed(2),0,1);if(isNaN(opacity))opacity=1;b.attr('data-opacity',opacity);swatch.find('span').css('opacity',opacity);y=keepWithin(opacitySlider.height()-(opacitySlider.height()*opacity),0,opacitySlider.height());opacityPicker.css('top',y+'px')}if(b.val().toLowerCase()==='transparent'){swatch.find('span').css('opacity',0)}swatch.find('span').css('backgroundColor',d);switch(settings.control){case'wheel':r=keepWithin(Math.ceil(hsb.s*0.75),0,grid.height()/2);phi=hsb.h*Math.PI/180;x=keepWithin(75-Math.cos(phi)*r,0,grid.width());y=keepWithin(75-Math.sin(phi)*r,0,grid.height());gridPicker.css({top:y+'px',left:x+'px'});y=150-(hsb.b/(100/grid.height()));if(d==='')y=0;sliderPicker.css('top',y+'px');slider.css('backgroundColor',hsb2hex({h:hsb.h,s:hsb.s,b:100}));break;case'saturation':x=keepWithin((5*hsb.h)/12,0,150);y=keepWithin(grid.height()-Math.ceil(hsb.b/(100/grid.height())),0,grid.height());gridPicker.css({top:y+'px',left:x+'px'});y=keepWithin(slider.height()-(hsb.s*(slider.height()/100)),0,slider.height());sliderPicker.css('top',y+'px');slider.css('backgroundColor',hsb2hex({h:hsb.h,s:100,b:hsb.b}));minicolors.find('.minicolors-grid-inner').css('opacity',hsb.s/100);break;case'brightness':x=keepWithin((5*hsb.h)/12,0,150);y=keepWithin(grid.height()-Math.ceil(hsb.s/(100/grid.height())),0,grid.height());gridPicker.css({top:y+'px',left:x+'px'});y=keepWithin(slider.height()-(hsb.b*(slider.height()/100)),0,slider.height());sliderPicker.css('top',y+'px');slider.css('backgroundColor',hsb2hex({h:hsb.h,s:hsb.s,b:100}));minicolors.find('.minicolors-grid-inner').css('opacity',1-(hsb.b/100));break;default:x=keepWithin(Math.ceil(hsb.s/(100/grid.width())),0,grid.width());y=keepWithin(grid.height()-Math.ceil(hsb.b/(100/grid.height())),0,grid.height());gridPicker.css({top:y+'px',left:x+'px'});y=keepWithin(slider.height()-(hsb.h/(360/slider.height())),0,slider.height());sliderPicker.css('top',y+'px');grid.css('backgroundColor',hsb2hex({h:hsb.h,s:100,b:100}));break}if(b.data('minicolors-initialized')){doChange(b,value,opacity)}}function doChange(a,b,c){var d=a.data('minicolors-settings'),lastChange=a.data('minicolors-lastChange');if(!lastChange||lastChange.value!==b||lastChange.opacity!==c){a.data('minicolors-lastChange',{value:b,opacity:c});if(d.change){if(d.changeDelay){clearTimeout(a.data('minicolors-changeTimeout'));a.data('minicolors-changeTimeout',setTimeout(function(){d.change.call(a.get(0),b,c)},d.changeDelay))}else{d.change.call(a.get(0),b,c)}}a.trigger('change').trigger('input')}}function rgbObject(a){var b=parseHex($(a).val(),true),rgb=hex2rgb(b),opacity=$(a).attr('data-opacity');if(!rgb)return null;if(opacity!==undefined)$.extend(rgb,{a:parseFloat(opacity)});return rgb}function rgbString(a,b){var c=parseHex($(a).val(),true),rgb=hex2rgb(c),opacity=$(a).attr('data-opacity');if(!rgb)return null;if(opacity===undefined)opacity=1;if(b){return'rgba('+rgb.r+', '+rgb.g+', '+rgb.b+', '+parseFloat(opacity)+')'}else{return'rgb('+rgb.r+', '+rgb.g+', '+rgb.b+')'}}function convertCase(a,b){return b==='uppercase'?a.toUpperCase():a.toLowerCase()}function parseHex(a,b){a=a.replace(/^#/g,'');if(!a.match(/^[A-F0-9]{3,6}/ig))return'';if(a.length!==3&&a.length!==6)return'';if(a.length===3&&b){a=a[0]+a[0]+a[1]+a[1]+a[2]+a[2]}return'#'+a}function parseRgb(a,b){var c=a.replace(/[^\d,.]/g,''),rgba=c.split(','),output;rgba[0]=keepWithin(parseInt(rgba[0],10),0,255);rgba[1]=keepWithin(parseInt(rgba[1],10),0,255);rgba[2]=keepWithin(parseInt(rgba[2],10),0,255);if(rgba[3]){rgba[3]=keepWithin(parseFloat(rgba[3],10),0,1)}if(b){return{r:rgba[0],g:rgba[1],b:rgba[2],a:rgba[3]?rgba[3]:null}}if(typeof(rgba[3])!=='undefined'&&rgba[3]<=1){return'rgba('+rgba[0]+', '+rgba[1]+', '+rgba[2]+', '+rgba[3]+')'}else{return'rgb('+rgba[0]+', '+rgba[1]+', '+rgba[2]+')'}}function parseInput(a,b){if(isRgb(a)){return parseRgb(a)}else{return parseHex(a,b)}}function keepWithin(a,b,c){if(a<b)a=b;if(a>c)a=c;return a}function isRgb(a){rgb=a.match(/^rgba?[\s+]?\([\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?/i);return(rgb&&rgb.length===4)?true:false}function getAlpha(a){a=a.match(/^rgba?[\s+]?\([\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?,[\s+]?(\d+(\.\d{1,2})?|\.\d{1,2})[\s+]?/i);return(a&&a.length===6)?a[4]:'1'}function hsb2rgb(a){var b={};var h=Math.round(a.h);var s=Math.round(a.s*255/100);var v=Math.round(a.b*255/100);if(s===0){b.r=b.g=b.b=v}else{var c=v;var d=(255-s)*v/255;var e=(c-d)*(h%60)/60;if(h===360)h=0;if(h<60){b.r=c;b.b=d;b.g=d+e}else if(h<120){b.g=c;b.b=d;b.r=c-e}else if(h<180){b.g=c;b.r=d;b.b=d+e}else if(h<240){b.b=c;b.r=d;b.g=c-e}else if(h<300){b.b=c;b.g=d;b.r=d+e}else if(h<360){b.r=c;b.g=d;b.b=c-e}else{b.r=0;b.g=0;b.b=0}}return{r:Math.round(b.r),g:Math.round(b.g),b:Math.round(b.b)}}function rgbString2hex(a){a=a.match(/^rgba?[\s+]?\([\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?/i);return(a&&a.length===4)?'#'+('0'+parseInt(a[1],10).toString(16)).slice(-2)+('0'+parseInt(a[2],10).toString(16)).slice(-2)+('0'+parseInt(a[3],10).toString(16)).slice(-2):''}function rgb2hex(c){var d=[c.r.toString(16),c.g.toString(16),c.b.toString(16)];$.each(d,function(a,b){if(b.length===1)d[a]='0'+b});return'#'+d.join('')}function hsb2hex(a){return rgb2hex(hsb2rgb(a))}function hex2hsb(a){var b=rgb2hsb(hex2rgb(a));if(b.s===0)b.h=360;return b}function rgb2hsb(a){var b={h:0,s:0,b:0};var c=Math.min(a.r,a.g,a.b);var d=Math.max(a.r,a.g,a.b);var e=d-c;b.b=d;b.s=d!==0?255*e/d:0;if(b.s!==0){if(a.r===d){b.h=(a.g-a.b)/e}else if(a.g===d){b.h=2+(a.b-a.r)/e}else{b.h=4+(a.r-a.g)/e}}else{b.h=-1}b.h*=60;if(b.h<0){b.h+=360}b.s*=100/255;b.b*=100/255;return b}function hex2rgb(a){a=parseInt(((a.indexOf('#')>-1)?a.substring(1):a),16);return{r:a>>16,g:(a&0x00FF00)>>8,b:(a&0x0000FF)}}$(document).on('mousedown.minicolors touchstart.minicolors',function(a){if(!$(a.target).parents().add(a.target).hasClass('minicolors')){hide()}}).on('mousedown.minicolors touchstart.minicolors','.minicolors-grid, .minicolors-slider, .minicolors-opacity-slider',function(a){var b=$(this);a.preventDefault();$(document).data('minicolors-target',b);move(b,a,true)}).on('mousemove.minicolors touchmove.minicolors',function(a){var b=$(document).data('minicolors-target');if(b)move(b,a)}).on('mouseup.minicolors touchend.minicolors',function(){$(this).removeData('minicolors-target')}).on('mousedown.minicolors touchstart.minicolors','.minicolors-swatch',function(a){var b=$(this).parent().find('.minicolors-input');a.preventDefault();show(b)}).on('focus.minicolors','.minicolors-input',function(){var a=$(this);if(!a.data('minicolors-initialized'))return;show(a)}).on('blur.minicolors','.minicolors-input',function(){var b=$(this),keywords=b.attr('data-keywords'),settings=b.data('minicolors-settings'),hex,rgba,swatchOpacity;if(!b.data('minicolors-initialized'))return;keywords=!keywords?[]:$.map(keywords.split(','),function(a){return $.trim(a.toLowerCase())});if(b.val()!==''&&$.inArray(b.val().toLowerCase(),keywords)>-1){value=b.val()}else{if(isRgb(b.val())){rgba=parseRgb(b.val(),true)}else{hex=parseHex(b.val(),true);rgba=hex?hex2rgb(hex):null}if(rgba===null){value=settings.defaultValue}else if(settings.format==='rgb'||rgba.a<1){value=settings.opacity?parseRgb('rgba('+rgba.r+','+rgba.g+','+rgba.b+','+b.attr('data-opacity')+')'):parseRgb('rgb('+rgba.r+','+rgba.g+','+rgba.b+')')}else{value=rgb2hex(rgba)}}swatchOpacity=settings.opacity?b.attr('data-opacity'):1;if(value.toLowerCase()==='transparent')swatchOpacity=0;b.closest('.minicolors').find('.minicolors-swatch > span').css('opacity',swatchOpacity);b.val(value);if(b.val()==='')b.val(parseInput(settings.defaultValue,true));b.val(convertCase(b.val(),settings.letterCase))}).on('keydown.minicolors','.minicolors-input',function(a){var b=$(this);if(!b.data('minicolors-initialized'))return;switch(a.keyCode){case 9:hide();break;case 13:case 27:hide();b.blur();break}}).on('keyup.minicolors','.minicolors-input',function(){var a=$(this);if(!a.data('minicolors-initialized'))return;updateFromInput(a,true)}).on('paste.minicolors','.minicolors-input',function(){var a=$(this);if(!a.data('minicolors-initialized'))return;setTimeout(function(){updateFromInput(a,true)},1)})}));